unit stackfrm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, fx_filters, ExtCtrls, StdCtrls, pngimage;

type
  TfrmStack = class(TForm)
    Image1: TImage;
    fxGaussianBlur1: TfxGaussianBlur;
    fxFillRGB1: TfxFillRGB;
    fxNormalBlend1: TfxNormalBlend;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
  private
    { Private declarations }
    Source, Dest: TBitmap;
  public
    { Public declarations }
  end;

var
  frmStack: TfrmStack;

implementation

{$R *.dfm}

procedure TfrmStack.FormCreate(Sender: TObject);
begin
  // Create 32-bit TBitmap source for better performance
  Source := TBitmap.Create;
  Source.Assign(Image1.Picture.Graphic);
end;

procedure TfrmStack.FormDestroy(Sender: TObject);
begin
  // We need to free Source. All Output bitmaps auto-free
  FreeAndNil(Source);
end;

procedure TfrmStack.FormPaint(Sender: TObject);
begin
  if Dest <> nil then
    Canvas.Draw((ClientWidth - Dest.Width) div 2, (ClientHeight - Source.Height) div 2, Dest)
  else
    Canvas.Draw((ClientWidth - Source.Width) div 2, (ClientHeight - Source.Height) div 2, Source)
end;

procedure TfrmStack.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  // Set source for 1 effect
  fxFillRGB1.Input := Source;
  fxFillRGB1.Color := $FFff3300;
  // Use result of 1 effect as source to 2 effect
  fxGaussianBlur1.BlurAmount := ((Y + X) / 2 / ClientHeight) * 6;
  // Use result of 2 effect as source to 3 effect
  fxNormalBlend1.Target := Source;
  // Get final result from last effect
  Dest := TBitmap(fxNormalBlend1.Output);
  // Repaint
  Canvas.Draw((ClientWidth - Dest.Width) div 2, (ClientHeight - Source.Height) div 2, Dest);
end;

end.
